--
-- Fendt vario 700 series
-- Specialization class for Fendt 700 series
-- @Authors of original scripts used: Manuel Leithner (SFM-Modding),Modelleicher (www.schwabenmodding.bplaced.net),Templaer, JoXXer, Knagsted, Mofa-Killer, Face, Heady, other do not remember!!
-- @author  Ago-Modding
-- @date  2/10/2015
---@ fix by Stefan Biedenstein (mogli)
--    for use this specialization on your mods...
--     @ Ago-Systemtech: https://www.facebook.com/ago.systemtech (Modhoster Team)
--    free for non commercial-usage! -------------
Vario700serieV2 = {};
function Vario700serieV2.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;
function Vario700serieV2:load(savegame)
    self.isSelectable = true
    -- self.LucePorta = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LucePorta#index"));
    -- self.doorIObject = nil;
    ---------------------CAM INTERNA MOBILE---------------------
    self.internalCamera = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.internalCamera#index"));
    self.camPositionX = 0;
    self.camPositionZ = 0;
    self.camPositionY = 0;
    
    self.updateFuelIndicators = SpecializationUtil.callSpecializationsFunction("updateFuelIndicators");
    self.ledriserva = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ledriserva#index"));
    self.ledriservaActive = false;
    self.riserva = 60;
    ------------REALISTIC INDOOR CAM------------
    self.ric = {};
    self.ric.directionPart = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.realisticIndoorCam#directionPart"));

    ----------------------- FRONT WIPER ANIMATION---------------------
    local wiperFrontAnimRootNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.wiperFront#rootNode"));
    self.wiperFrontAnimCharSet = 0;
    if wiperFrontAnimRootNode ~= nil and wiperFrontAnimRootNode ~= 0 then
        self.wiperFrontAnimCharSet = getAnimCharacterSet(wiperFrontAnimRootNode);
        if self.wiperFrontAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.wiperFrontAnimCharSet, getXMLString(self.xmlFile, "vehicle.wiperFront#clip"));
            assignAnimTrackClip(self.wiperFrontAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.wiperFrontAnimCharSet, 0, true);
            local wiperFrontAnimSpeedScale = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.wiperFront#speedScale"), 1);
            setAnimTrackSpeedScale(self.wiperFrontAnimCharSet, 0, wiperFrontAnimSpeedScale);
            self.wiperFrontAnimDuration = getAnimClipDuration(self.wiperFrontAnimCharSet, clip);
        end;
    end;
    self.iswiperFrontActive = false;
    self.finishwiperFront = true;
    --------------------------REAR WIPER ANIMATION----------------------
    local wiperBackAnimRootNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.wiperBack#rootNode"));
    self.wiperBackAnimCharSet = 0;
    if wiperBackAnimRootNode ~= nil and wiperBackAnimRootNode ~= 0 then
        self.wiperBackAnimCharSet = getAnimCharacterSet(wiperBackAnimRootNode);
        if self.wiperBackAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.wiperBackAnimCharSet, getXMLString(self.xmlFile, "vehicle.wiperBack#clip"));
            assignAnimTrackClip(self.wiperBackAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.wiperBackAnimCharSet, 0, true);
            local wiperBackAnimSpeedScale = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.wiperBack#speedScale"), 1);
            setAnimTrackSpeedScale(self.wiperBackAnimCharSet, 0, wiperBackAnimSpeedScale);
            self.wiperBackAnimDuration = getAnimClipDuration(self.wiperBackAnimCharSet, clip);
        end;
    end;
    self.iswiperBackActive = false;
    self.finishwiperBack = true;
    -------------------------PEDALI-------------------------
    local PedaleGasNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.PedaleGas#index"));
    if PedaleGasNode ~= nil then
        self.PedaleGas = {};
        self.PedaleGas.node = PedaleGasNode;
        self.PedaleGas.maxSpeed = getXMLInt(self.xmlFile, "vehicle.PedaleGas#maxSpeed");
        local x1,y1,z1 = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.PedaleGas#minRot"));
        local x2,y2,z2 = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.PedaleGas#maxRot"));
        self.PedaleGas.rotMin = {math.rad(Utils.getNoNil(x1,0)),math.rad(Utils.getNoNil(y1,0)),math.rad(Utils.getNoNil(z1,0))};
        self.PedaleGas.rotMax = {math.rad(Utils.getNoNil(x2,0)),math.rad(Utils.getNoNil(y2,0)),math.rad(Utils.getNoNil(z2,0))};
    end;
    local PedaleFrenoNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.PedaleFreno#index"));
    if PedaleFrenoNode ~= nil then
        self.PedaleFreno = {};
        self.PedaleFreno.node = PedaleFrenoNode;
        local x1,y1,z1 = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.PedaleGas#minRot"));
        local x2,y2,z2 = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.PedaleGas#maxRot"));
        self.PedaleFreno.rotMin = {math.rad(Utils.getNoNil(x1,0)),math.rad(Utils.getNoNil(y1,0)),math.rad(Utils.getNoNil(z1,0))};
        self.PedaleFreno.rotMax = {math.rad(Utils.getNoNil(x2,0)),math.rad(Utils.getNoNil(y2,0)),math.rad(Utils.getNoNil(z2,0))};
        self.PedaleFreno.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.PedaleFreno#rotTime"), 1)*1000;
        self.PedaleFrenoIsActive = false;
    end;
    -------------------------- LEVE ----------------------
    self.levaindicatori = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.levaindicatori#index"));
    self.LevaHandbrake = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LevaHandbrake#index"));
    self.HANDBRAKE_LED = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.HANDBRAKE_LED#index"));
    --------------------------LED-------------------------
    self.batteriaicona = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.batteriaicona#index"));
    self.candelette = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.candelette#index"));
    self.DASHBOARD_ON = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.DASHBOARD_ON#index"));
    self.Olio_Led = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Olio_Led#index"));
    self.LedHazard = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LedHazard#index"));
    self.ledLampeggiante = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.ledLampeggiante#index"));
    self.LedStart = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LedStart#index"));
	self.LedPush = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LedPush#index"));
    self.Display_Digitali = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Display_Digitali#index"));
    self.ledFrontwork = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.ledFrontwork#index"));
    self.ledRearwork = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.ledRearwork#index"));
    self.LedBraccio = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LedBraccio#index"));
    self.PTOLed = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.PTOLed#index"));
    self.MONITOR_VARIO_HIRED = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.MONITOR_VARIO_HIRED#index"));
    self.Cruise = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Cruise#index"));
    self.LED_AVANTI = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LED_AVANTI#index"));
    self.LED_INDIETRO = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LED_INDIETRO#index"));
    ------------------ SWITCHES---------------
    self.numSwitches = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.switches#count"),0);
    self.switch = {};
    for i=1, self.numSwitches do
        local objname = string.format("vehicle.switches.switch" .. "%d", i);
        self.switch[i] = {};
        self.switch[i] = Utils.indexToObject(self.components, getXMLString(self.xmlFile, objname .. "#index"));
    end;
    ------------- GASOLIO INDICATORI----------
    self.fuelIndicatorsGroup = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.fuelIndicators#index"));
    self.numFuelIndicators = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.fuelIndicators#count"), 0);
    self.fuelIndicators = {};
    for i=1, self.numFuelIndicators do
        local objname = string.format("vehicle.fuelIndicators.fuelIndicator" .. "%d", i);
        self.fuelIndicators[i] = {};
        self.fuelIndicators[i].rotNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, objname .. "#rotNode"));
        setVisibility(self.fuelIndicators[i].rotNode,true);
    end;
    ------------- ROTORE LAMPEGGIANTE----------
    self.RotoreLampe1 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.RotoreLampe1#index"));
    self.RotoreLampe2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.RotoreLampe2#index"));
         --------------------------GIUNTI ASSALE------------------------
    self.giuntoDestro = {};
    self.giuntoDestro.node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.giuntoDestro#index"));
    self.giuntoDestro.speedFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.giuntoDestro#speedFactor"), 2);
    self.giuntoSinistro = {};
    self.giuntoSinistro.node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.giuntoSinistro#index"));
    self.giuntoSinistro.speedFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.giuntoSinistro#speedFactor"), 2);
    -----------------SOUND RISERVA------------------
    fuelwarningSoundFile = Utils.getFilename("Sound/fuelwarning.wav", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
    self.playedSound = false;
    
    -- MOGLI START --
    ---------------FREEEZE STEERING---------------
    self.freezeRotatedTime = 0
    -- self.getIsActiveForInputNew = Vario700serieV2.getIsActiveForInputNew
    self.getIsActiveForInput = Vario700serieV2.getIsActiveForInputNew
    -- MOGLI END --
end;
function Vario700serieV2:delete()
end;
function Vario700serieV2:readStream(streamId, connection)
end;
function Vario700serieV2:writeStream(streamId, connection)
end;
function Vario700serieV2:readUpdateStream(streamId, timestamp, connection)
end;
function Vario700serieV2:writeUpdateStream(streamId, connection, dirtyMask)
end;
function Vario700serieV2:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Vario700serieV2:keyEvent(unicode, sym, modifier, isDown)
end;

    -- MOGLI START --
    
function Vario700serieV2:getIsActiveForInputNew(onlyTrueIfSelected)
    if g_gui.currentGui ~= nil or g_currentMission.isPlayerFrozen then
        return false;
    end;

    if self.isEntered then
        if onlyTrueIfSelected == nil or onlyTrueIfSelected then
            return self.selectedImplement == nil;
        else
            return true;
        end;
    end;

    return false;
end;

    -- MOGLI END --

function Vario700serieV2:update(dt)
    -------------LIFT-HIDRO----------------
    if self:getIsActive() then
    if self.isMotorStarted then
        if self.isHired == true then
                setVisibility(self.MONITOR_VARIO_HIRED, true);
                setVisibility(self.Cruise, true);            
            else
                setVisibility(self.MONITOR_VARIO_HIRED, false);
                setVisibility(self.Cruise , false);            
        end;
        
    end;
    -- MOGLI START --

    --------------------------GIUNTI ASSALE------------------------
        local x,y,z = getRotation(self.wheels[1].driveNode);
        setRotation(self.giuntoDestro.node, 0 ,0, x*self.giuntoDestro.speedFactor);
        local x,y,z = getRotation(self.wheels[1].driveNode);
        setRotation(self.giuntoSinistro.node, 0 ,0, x*self.giuntoSinistro.speedFactor);
    end;
    ------------------LED RISERVA----------------------
    if self.isEntered then
        if self.fuelFillLevel < 60 then
            self.riserva = self.riserva - dt;
            if self.playedSound == false then
                playSample(self.fuelwarningSoundId,1,1,0);
                self.playedSound = true;
            end;
            self.ledriservaActive = true;
        else
            self.playedSound = false;
            self.ledriservaActive = false;
        end;
        setVisibility(self.ledriserva,self.ledriservaActive);
        self:updateFuelIndicators();
    end;
    ---------------------CAM INTERNA MOBILE---------------------
      if self.camIndex == 2 then
     if self:getIsActive() then
        if InputBinding.isPressed(InputBinding.MOVECAMLEFT2) then
            self.camPositionX = self.camPositionX + 0.03;
            if self.camPositionX >= 0.3 then
                self.camPositionX = 0.3;
            end;
        end;
        if InputBinding.isPressed(InputBinding.MOVECAMRIGHT2) then
            self.camPositionX = self.camPositionX - 0.03;
            if self.camPositionX <= -0.3 then
                self.camPositionX = -0.3;
            end;
        end;
        if InputBinding.isPressed(InputBinding.MOVECAMFORWARD2) then
            self.camPositionZ = self.camPositionZ + 0.03;
            if self.camPositionZ >= 0.3 then
                self.camPositionZ = 0.3;
            end;
        end;
                if InputBinding.isPressed(InputBinding.MOVECAMBACK2) then
            self.camPositionZ = self.camPositionZ - 0.03;
            if self.camPositionZ <= -0.2 then
                self.camPositionZ = -0.2;
            end;
        end;
        if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
            self.camPositionY = self.camPositionY + 0.02;
            if self.camPositionY >= 0.15 then
                self.camPositionY = 0.15;
            end;
        end;
        if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then
            self.camPositionY = self.camPositionY - 0.02;
            if self.camPositionY <= -0.2 then
                self.camPositionY = -0.2;
            end;
        end;
        if Input.isKeyPressed(Input.KEY_z) then
            self.camPositionX = 0;
            self.camPositionZ = 0;
            self.camPositionY = 0;
        end;
        if self.internalCamera ~= nil then
            setTranslation(self.internalCamera, self.camPositionX, self.camPositionZ, self.camPositionY);
        end;
       end;
    end;
    --------------REALISTIC INDOOR CAM------------------------
    if self:getIsActive() then
            local ax, ay, az = getWorldTranslation(self.ric.directionPart);
            local bx = 0;
            local by = 1100000;
            local bz = 0;
            x, y, z = worldDirectionToLocal(getParent(self.ric.directionPart), bx-ax, by-ay, bz-az);
            setDirection(self.ric.directionPart, x, y, z, 0, 0, 1);
                ------------------LAMPEGGIANTI------------------
        if self.beaconLightsActive then
            rotate(self.RotoreLampe1, 0, self.beaconLights[1].speed*dt, 0);
            rotate(self.RotoreLampe2, 0, self.beaconLights[2].speed*dt, 0);
        end;
    end;
end;
function Vario700serieV2:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    return BaseMission.VEHICLE_LOAD_OK;
end;
function Vario700serieV2:updateTick(dt)
    -- MOGLI START --
    ---------------FREEEZE STEERING---------------
    if self.isMotorStarted then    
        self.freezeRotatedTime = self.rotatedTime
    elseif self:getIsActive() then
        self.rotatedTime = self.freezeRotatedTime
    end
    -- MOGLI END --
    
  if self:getIsActive() then
        if self.isMotorStarted then    
            setVisibility(self.batteriaicona, false);
            setVisibility(self.candelette, false);
            setVisibility(self.DASHBOARD_ON, true);
            setVisibility(self.Olio_Led, true);
            setVisibility(self.LedStart, true);
			setVisibility(self.LedPush, true); 
            setVisibility(self.Display_Digitali, true);
            setVisibility(self.fuelIndicatorsGroup, true);
            setVisibility(self.LedBraccio, true);
        else        
            setVisibility(self.batteriaicona, true);
            setVisibility(self.candelette, true);
            setVisibility(self.DASHBOARD_ON, false);
            setVisibility(self.Olio_Led, false);
            setVisibility(self.LedStart, false);
			setVisibility(self.LedPush, false); 
            setVisibility(self.Display_Digitali, false);
            setVisibility(self.fuelIndicatorsGroup, false);
            setVisibility(self.LedBraccio, false);
        end;
        for k, implement in pairs(self.attachedImplements) do
                if implement.object ~= nil then
                    if implement.object.isTurnedOn then
                        setVisibility(self.PTOLed, true);
                    else
                        setVisibility(self.PTOLed, false);
                    end;
                end;
        end;
        -------------------PEDALI--------------------------------
        if self.camIndex == 1 then
             if self.PedaleGas ~= nil then
                local percent = (self.lastSpeed*self.speedDisplayScale*3600) / self.PedaleGas.maxSpeed;
                local minRot = self.PedaleGas.rotMin;
                local maxRot = self.PedaleGas.rotMax;
                local x = minRot[1] + (maxRot[1] - minRot[1]) * percent;
                local y = minRot[2] + (maxRot[2] - minRot[2]) * percent;
                local z = minRot[3] + (maxRot[3] - minRot[3]) * percent;
                setRotation(self.PedaleGas.node, x, y, z);
            end;
        end;
        if self.camIndex == 2 then
            if self.PedaleGas ~= nil then
                local percent = (self.lastSpeed*self.speedDisplayScale*3600) / self.PedaleGas.maxSpeed;
                local minRot = self.PedaleGas.rotMin;
                local maxRot = self.PedaleGas.rotMax;
                local x = minRot[1] + (maxRot[1] - minRot[1]) * percent;
                local y = minRot[2] + (maxRot[2] - minRot[2]) * percent;
                local z = minRot[3] + (maxRot[3] - minRot[3]) * percent;
                setRotation(self.PedaleGas.node, x, y, z);
            end;
        end;
    end;
        ---------------------- WIPERS -----------------
    if self.isMotorStarted then
        if not self.finishwiperFront then
            if getAnimTrackTime(self.wiperFrontAnimCharSet, 0) % self.wiperFrontAnimDuration <= 100 then
                setAnimTrackTime(self.wiperFrontAnimCharSet, 0, 0.0);
                disableAnimTrack(self.wiperFrontAnimCharSet, 0);
                self.finishwiperFront = true;
            end;
        end;
        if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
            if not self.iswiperFrontActive then
                enableAnimTrack(self.wiperFrontAnimCharSet, 0);
                self.iswiperFrontActive = true;
            end;
        else
            if self.iswiperFrontActive then
                self.iswiperFrontActive = false;
                self.finishwiperFront = false;
            end;
        end;
        if not self.finishwiperBack then
            if getAnimTrackTime(self.wiperBackAnimCharSet, 0) % self.wiperBackAnimDuration <= 100 then
                setAnimTrackTime(self.wiperBackAnimCharSet, 0, 0.0);
                disableAnimTrack(self.wiperBackAnimCharSet, 0);
                self.finishwiperBack = true;
            end;
        end;
        if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
            if not self.iswiperBackActive then
                enableAnimTrack(self.wiperBackAnimCharSet, 0);
                self.iswiperBackActive = true;
            end;
        else
            if self.iswiperBackActive then
                self.iswiperBackActive = false;
                self.finishwiperBack = false;
            end;
        end;
        for _, part in pairs(self.movingParts) do
            part.isDirty = true;
        end;
    end;
    --------------------SWITCH------------------------------
    
    if self.switch[1] ~= nil then
        if self.isMotorStarted then
            setRotation(self.switch[1], math.rad(0), math.rad(-60), math.rad(0));
        else
            setRotation(self.switch[1], math.rad(0), math.rad(0), math.rad(0));
        end;
    end;
    -- if self.LevaHandbrake ~= nil then
        -- if      self.dCcheckModule ~= nil 
                -- and self.driveControl  ~= nil
                -- and self:dCcheckModule("handBrake")
                -- and self.driveControl.handBrake.isActive then
            -- setRotation(self.LevaHandbrake, math.rad(0), math.rad(0), math.rad(0));
        -- else
            -- setRotation(self.LevaHandbrake, math.rad(90), 0, 0);
        -- end;
    -- end;
    -- if self.HANDBRAKE_LED ~= nil then
        -- if  self.dCcheckModule ~= nil 
                -- and self.driveControl  ~= nil
                -- and self:dCcheckModule("handBrake")
                -- and self.driveControl.handBrake.isActive then
            -- setVisibility(self.HANDBRAKE_LED, true);
            -- setVisibility(self.LedStart, true);
        -- else
            -- setVisibility(self.HANDBRAKE_LED, false);
            -- setVisibility(self.LedStart, false);
        -- end;
    -- end
    -- if self.ledFrontwork ~= nil then
         -- local i = 1
         -- if self.B3.work[i].a then
            -- setVisibility(self.ledFrontwork, true);
        -- else
            -- setVisibility(self.ledFrontwork, false);
        -- end;
     -- end;
    -- if self.ledRearwork ~= nil then
         -- local i = 2
         -- if self.B3.work[i].a then
            -- setVisibility(self.ledRearwork, true);
        -- else
            -- setVisibility(self.ledRearwork, false);
        -- end;
    -- end;
    -- if self.LucePorta ~= nil and self.doorIObject ~= nil then
        -- setVisibility(self.LucePorta, self.doorIObject.isOpen);
    -- end;
    
    -- MOGLI START --
    -- if self.levaindicatori ~= nil then
        -- local targetAngle = 0
        -- if     self.turnSignalState == Vehicle.TURNSIGNAL_LEFT then 
            -- targetAngle = 20
        -- elseif self.turnSignalState == Vehicle.TURNSIGNAL_RIGHT then 
            -- targetAngle = -20
        -- end
        -- setRotation( self.levaindicatori, 0, 0, math.rad( targetAngle ) )
    -- end
    
    -- if self.LedHazard  ~= nil then
        -- if self.turnSignalState == Vehicle.TURNSIGNAL_HAZARD then
            -- setVisibility(self.LedHazard , true);
        -- else
            -- setVisibility(self.LedHazard , false);
        -- end;
    -- end;

    if self.l2gsGetShuttleDirection ~= nil then
        local dir = self:l2gsGetShuttleDirection()
        if     dir > 0 then
            setVisibility(self.LED_AVANTI, true);
            setVisibility(self.LED_INDIETRO, false);
            setVisibility(self.LedStart, false);
        elseif dir < 0 then
            setVisibility(self.LED_INDIETRO, true);
            setVisibility(self.LED_AVANTI, false);
            setVisibility(self.LedStart, false);
        else
            setVisibility(self.LED_INDIETRO, false);
            setVisibility(self.LED_AVANTI, false);
            setVisibility(self.LedStart, true);
        end;
    end
    -- MOGLI END --
    
    if self.ledLampeggiante ~= nil then
         if self.beaconLightsActive then
            setVisibility(self.ledLampeggiante, true);
         else
           setVisibility(self.ledLampeggiante, false);
        end;
    end;
end;
function Vario700serieV2:updateFuelIndicators()
    local amountOfFuelPerIndicator = self.fuelCapacity/11;
    local timesToIterate = self.fuelFillLevel/amountOfFuelPerIndicator;
    timesToIterate = math.floor(timesToIterate);
    if self.oldTimesToIterate ~= timesToIterate then
        for i=1, self.numFuelIndicators do
            setVisibility(self.fuelIndicators[i].rotNode, false);
        end;
        for i=1, timesToIterate do
            setVisibility(self.fuelIndicators[i].rotNode, true);
        end;
    end;
    self.oldTimesToIterate = timesToIterate;
end;
function Vario700serieV2:draw()
  -- MOGLI START --

    if self.l2gsDrawShuttleDirection ~= nil then
        self:l2gsDrawShuttleDirection()
    end
    -- MOGLI END --
 
end;
function Vario700serieV2:onEnter()
        if self.isMotorStarted then
            setVisibility(self.batteriaicona, false);
            setVisibility(self.candelette, false);
            setVisibility(self.DASHBOARD_ON, true);
             setVisibility(self.Olio_Led, true);
            setVisibility(self.LedBraccio, true);
            setVisibility(self.Display_Digitali, true);
          
        else
 
            setVisibility(self.batteriaicona, true);
            setVisibility(self.candelette, true);
            setVisibility(self.DASHBOARD_ON, false);
             setVisibility(self.Olio_Led, false);
            setVisibility(self.LedBraccio, false);
            setVisibility(self.Display_Digitali, false);
        end
    if self.iswiperFrontActive then
        enableAnimTrack(self.wiperFrontAnimCharSet, 0);
    end;
        if self.iswiperBackActive then
        enableAnimTrack(self.wiperBackAnimCharSet, 0);
    end;
end;
function Vario700serieV2:attachImplement(implement)

end;
function Vario700serieV2:detachImplement(implementIndex)

end;

function Vario700serieV2:onLeave()
        if self.isMotorStarted then
            setVisibility(self.batteriaicona, false);
            setVisibility(self.candelette, false);
            setVisibility(self.DASHBOARD_ON, true);
             setVisibility(self.Olio_Led, true);
            setVisibility(self.Display_Digitali, true);
            setVisibility(self.LedBraccio, true);
        else
            setVisibility(self.batteriaicona, true);
            setVisibility(self.candelette, true);
            setVisibility(self.DASHBOARD_ON, false);
             setVisibility(self.Olio_Led, false);
            setVisibility(self.Display_Digitali, false);
            setVisibility(self.LedBraccio, false);
         end
    if self.iswiperBackActive then
        disableAnimTrack(self.wiperBackAnimCharSet, 0);
    end;
        if self.iswiperFrontActive then
        disableAnimTrack(self.wiperFrontAnimCharSet, 0);
    end;
end;